#include "StdAfx.h"
#include "DialPadManager.h"
#include "DialPadDlg.h"

CDialPadManager *CDialPadManager::g_pDialPadManager = NULL;

CDialPadManager* CDialPadManager::GetDialpadManager()
{	
	if (g_pDialPadManager == NULL)
	{
		g_pDialPadManager = new CDialPadManager;
	}

	return g_pDialPadManager;
}

void CDialPadManager::DeleteDialPad()
{
	if (g_pDialPadManager)
	{
		if (g_pDialPadManager->DeleteView())
		{
			delete g_pDialPadManager;
			g_pDialPadManager = NULL;
		}
	}
}

void CDialPadManager::ShowDialPad()
{
	if (m_pDialPadDlg == NULL)
	{
		bool bCreateSuccess = CreateDialPadView();

		if (!bCreateSuccess)
			return;
	}

	m_pDialPadDlg->ShowWindow(SW_SHOW);
	m_pDialPadDlg->SetForegroundWindow();
}

void CDialPadManager::MakeCall(NE_MEMBER_DATA userData, CString strTelNo)
{
	if (m_pDialPadDlg == NULL)
	{
		bool bCreateSuccess = CreateDialPadView();

		if (!bCreateSuccess)
			return;
	}

	// ȸȭ, ȣ, ޴  ϳ ȸ  ִ 쿡   ش.
	//   ʱ ȭ 
	if (GET_CONFIG()->EnableFunction(_T("SR_05")) ||
		GET_CONFIG()->EnableFunction(_T("SR_07")) ||
		GET_CONFIG()->EnableFunction(_T("SR_08")))
		m_pDialPadDlg->SetCallInfo(userData, strTelNo);

	m_pDialPadDlg->ShowWindow(SW_SHOW);
	m_pDialPadDlg->SetForegroundWindow();
	m_pDialPadDlg->OnBnClickedMakecallButton();
}

bool CDialPadManager::DeleteView()
{
	if (m_pDialPadDlg)
	{
		m_pDialPadDlg->DestroyWindow();
		delete m_pDialPadDlg;
		m_pDialPadDlg = NULL;
	}

	return true;
}

bool CDialPadManager::CreateDialPadView()
{
	if (m_pDialPadDlg->GetSafeHwnd())
	{
		m_pDialPadDlg->SetForegroundWindow();
	}
	else
	{
		m_pDialPadDlg = new CDialPadDlg(CWnd::GetDesktopWindow());

		if (m_pDialPadDlg == NULL)
			return false;

		if (m_pDialPadDlg->Create(CDialPadDlg::IDD, CWnd::GetDesktopWindow()) == FALSE)
		{
			delete m_pDialPadDlg;
			m_pDialPadDlg = NULL;
			
			return false;
		}
	}

	return true;
}


CDialPadManager::CDialPadManager(void) : m_pDialPadDlg(NULL)
{
}

CDialPadManager::~CDialPadManager(void)
{
}

void CDialPadManager::UpdateCallStatus(NTIPTStatusType ipt_status)
{
	if( m_pDialPadDlg != NULL && m_pDialPadDlg->GetSafeHwnd() != NULL )
	{
		switch (ipt_status)
		{
		case iptstIDLE:
			m_pDialPadDlg->OnCallDisconnected();
			break;

		case iptstACTIVE:
			m_pDialPadDlg->OnCallConnected();
			break;

		case itpstALERTING:
			m_pDialPadDlg->OnCallAlerting();
			break;
		}
	}
}

void CDialPadManager::UpdateMyIptStatus(NTIPTStatusType ipt_status)
{
	if( m_pDialPadDlg != NULL && m_pDialPadDlg->GetSafeHwnd() != NULL )
	{
		if( ipt_status == iptstIDLE || ipt_status == iptstDND )
			m_pDialPadDlg->OnCallDisconnected();
	}
}

bool CDialPadManager::GetCallingStatus()
{
	if( m_pDialPadDlg != NULL && m_pDialPadDlg->GetSafeHwnd() != NULL )
	{
		return m_pDialPadDlg->GetCallingStatus();
	}

	return false;
}
